#include <cstring>
#include <cstdlib>
#include <cstdio>
#include <algorithm>

using namespace std;

const int maxn = 200001;

int n,k,t,w[maxn],b[maxn];
int g[maxn],next[maxn];

void Qsort(int l, int r)
{
   if (l >= r) return;
   int i=l,j=r,k=b[l+rand()%(r-l+1)];
   while (i < j) {
      while (b[i] < k) i++;
      while (b[j] > k) j--;
      if (i <= j) {swap(w[i],w[j]); swap(b[i],b[j]); i++; j--;}
   }
   if (l < j) Qsort(l,j);
   if (i < r) Qsort(i,r);
}

int main()
{
   srand(82954513);
   int i,j,ans;

   freopen("input.txt","rt",stdin); freopen("output.txt","wt",stdout);
   scanf("%d%d%d",&k,&n,&t);
   if (k > 200000 || n > 200000 || t > 1000) return 1;
   for (i = 1; i <= n; i++) {
      scanf("%d%d",&w[i],&b[i]); 
      if (w[i] > k || w[i] < 1) return 1;
   }
   
   Qsort(1,n); memset(g,0,sizeof(g));
   for (i = n; i >= 1; i--) {
      next[i] = g[w[i]]; g[w[i]] = i;
   }

   ans = 0;
   for (i = 1; i <= k; i++) {
      while (g[i] && b[g[i]] <= ans) g[i] = next[g[i]];
      while (g[i] && b[g[i]]-ans < t) {ans = b[g[i]]; g[i] = next[g[i]];}
      ans += t;
   }   

   printf("%d",ans);
   fclose(stdin); fclose(stdout);
   return 0;
}